<template>
  <v-container>
    <file-pond
      name="test"
      ref="pond"
      label-idle="Drop .tgz here..."
      accepted-file-types="application/gzip"
      max-files="1"
      :server="server"
      v-bind:files="files"
      v-on:add-file="handleFilePondInit"
      v-on:init="handleFilePondInit"
    />
  </v-container>
</template>

<script>
import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type';
import vueFilePond from 'vue-filepond';
import 'filepond/dist/filepond.min.css';
import upload from '../api/file';

const FilePond = vueFilePond(FilePondPluginFileValidateType);
export default {
  name: 'uploader',
  components: {
    FilePond,
  },
  data() {
    return {
      files: [],
      server: {
        // eslint-disable-next-line no-unused-vars
        process: (fieldName, file, metadata, load, error, progress, abort) => {
          const bucket = `${file.name.replace(/\.[^/.]+$/, '')}-${(new Date()).getTime()}`;
          this.$minio.makeBucket(bucket, 'us-east-1', (err) => {
            if (err) {
              // console.log('Error creating bucket.', err);
              return;
            }
            this.$minio.presignedPutObject(bucket, file.name, 60 * 60, (err2, presignedUrl) => {
              if (err2) {
                // console.log(err2);
                return;
              }
              upload(file, presignedUrl)
                .then(() => {
                  load(`${bucket}/${file.name}`);
                  this.$refs.pond.removeFiles();
                  this.$emit('dispatch');
                  this.$socket.emit('unzip', { bucket_name: bucket, object_name: file.name });
                })
                .catch(() => {});
            });
          });
        },
      },
    };
  },
  watch: {
    files: {
      handler: () => {
        // console.log(val);
      },
      deep: true,
    },
  },
  methods: {
    handleFilePondInit() {
      // console.log('FilePond has initialized');

      // FilePond instance methods are available on `this.$refs.pond`
      // console.log(this.$refs.pond.getFiles());
    },
  },
};
</script>

<style>
  .filepond--root {
    min-height: 50vh;
    font-size: 2rem;
  }
  .filepond--drop-label {
    height: 100%;
  }
</style>
